#include "ConstraintGenotypeC.h"
#include "EncounterC.h"
#include "FitnessC.cc"

extern MLCG RandomGenerator;



ConstraintGenotypeC::ConstraintGenotypeC
(
	ConstraintGeneT iVariable1,
	ConstraintGeneT iVariable2,
	UnsignedIntegerT iSizeOfFitnessHistory,
	RandomCspC * iProblem
)
{
	Variable1 = iVariable1;
	Variable2 = iVariable2;

	Fitness = new FitnessC <ConstraintGeneT> (iSizeOfFitnessHistory);
	
	Problem = iProblem;

} // ConstraintGenotypeC::ConstraintGenotypeC



/*ConstraintGenotypeC::ConstraintGenotypeC
(
	ConstraintGenotypeC & const iConstraintGenotype
)
{
} // ConstraintGenotypeC::ConstraintGenotypeC
*/


ConstraintGenotypeC::~ConstraintGenotypeC ()
{
	delete Fitness;

} // ConstraintGenotypeC::~ConstraintGenotypeC



void const ConstraintGenotypeC::InitialiseFitness
(
	EncounterC * iEncounter
)
{
	iEncounter->DoIt (this);

} // ConstraintGenotypeC::InitialiseFitness



ConstraintGenotypeC const & ConstraintGenotypeC::operator=
(
	ConstraintGenotypeC const & iConstraintGenotype
)
{
	cerr << "ConstraintGenotypeC = " << endl;
	if (this != &iConstraintGenotype)
	{
		*(Fitness) = iConstraintGenotype.Fitness [0];
		Variable1 = iConstraintGenotype.GetVariable1 ();
		Variable2 = iConstraintGenotype.GetVariable2 ();
		Problem = iConstraintGenotype.Problem;
	}

	return (*this);

} // ConstraintGenotypeC::operator=



void const ConstraintGenotypeC::Print() const
{
	cout << setw (4) << GetVariable1 () << setw (4) << GetVariable2 () 
		<< setw (4) << "<" << GetFitnessValue () << ">" << endl;

} // ConstraintGenotypeC::Print



/*
void const ConstraintGenotypeC::Print(FileC iFile) const
{
} // ConstraintGenotypeC::Print
*/



ConstraintFitnessT const ConstraintGenotypeC::GetFitnessValue () const
{
	return (Fitness->GetFitness ());
	
} // ConstraintGenotypeC::GetFitnessValue


void const ConstraintGenotypeC::UpdateFitness
(
	BoolT iReward
)
{
	if (iReward)
		Fitness->UpdateFitness (1);
	else
		Fitness->UpdateFitness (0);

} // ConstraintGenotypeC::UpdateHistory



ConstraintGeneT const ConstraintGenotypeC::GetVariable1 () const
{
	return (Variable1);

} // ConstraintGenotypeC::GetVariable1



ConstraintGeneT const ConstraintGenotypeC::GetVariable2 () const
{
	return (Variable2);

} // ConstraintGenotypeC::GetVariable2



// eof ConstraintGenotypeC.cc
