#ifndef ConstraintPopulationC_h
#define ConstraintPopulationC_h 1

#include "../Common/ArrayC.h"
#include "ConstraintGenotypeC.h"
#include "SelectionC.h"
#include "PopulationPoolC.h"
#include <MLCG.h>

class ConstraintPopulationC 
{
	public:
		
		ConstraintPopulationC
		(
		 	UnsignedIntegerT const iSizeOfFitnessHistory,
			SelectionC * iSelection,
			RandomCspC * iProblem
		);

		~ConstraintPopulationC ();

		ConstraintFitnessT const GetFitnessOfBestGenotype ();

		void const InitialiseFitness
		(
			EncounterC * iEncounter
		);

		void const Print () const;

		void const ConstraintPopulationC::InjectGenotype
		(
			ConstraintGenotypeC * iConstraintGenotype
		);
		ConstraintGenotypeC * FetchGenotype ();

		UnsignedIntegerT const GetFitnessOfBestGenotype () const;
		UnsignedIntegerT const GetSize () const;

	protected:

	private:

		UnsignedIntegerT SizeOfConstraintPopulation;
		UnsignedIntegerT SizeOfFitnessHistory;

		PopulationPoolC <ConstraintGenotypeC *> * Pool;

		UnsignedIntegerT GenerationNumber;

		RandomCspC * Problem;
		SelectionC * Selection;

}; // ConstraintPopulationC



#endif

// eof ConstraintPopulationC.h
