
#include "FitnessC.h"
#include "../Common/ArrayC.t"



template <class T>
FitnessC<T>::FitnessC
(
	UnsignedIntegerT iHistorySize
)
{
	HistoryPointer = 0;

	HistorySize = iHistorySize;

	Fitness = 0;

	History = new ArrayC <T> (HistorySize);

	for (UnsignedIntegerT i = 0; i < HistorySize; i++)
		(*History) [i] = 0;

} // FitnessC::FitnessC
		


template <class T>
FitnessC<T>::~FitnessC ()
{
	delete History;

} // FitnessC::~FitnessC



template <class T>
FitnessC<T> const & FitnessC<T>::operator=
(
	FitnessC<T> const & iFitness
)
{
	if (this != &iFitness)
	{
		Fitness = iFitness.Fitness;
		*History = iFitness.History [0];
		HistoryPointer = iFitness.HistoryPointer;
		HistorySize = iFitness.HistorySize;
	}

	return (*this);

} // FitnessC::operator=



template <class T>
void const FitnessC<T>::UpdateFitness
(
	T iNew
)
{
	Fitness = Fitness - (*History) [HistoryPointer] + iNew;

	(*History) [HistoryPointer] = iNew;

	HistoryPointer = (HistoryPointer + 1) % HistorySize;

} // FitnessC::UpdateFitness



template <class T>
T const FitnessC<T>::GetFitness () const
{
	return (Fitness);

} // FitnessC::GetFitness

// eof FitnessC.cc
