
#ifndef PopulationPoolC_h
#define PopulationPoolC_h 1

#include "../Types.h"

template <class T>
class PopulationPoolC 
{
	public:
		
		PopulationPoolC
		(
			UnsignedIntegerT const iMaximumSizeOfPopulation
		);

		~PopulationPoolC ();

		void const First ();
		void const Last ();
		void const Previous ();
		void const Next ();
		void const None ();

		BoolT const IsEnd () const;
		T Current () const;

		void const Insert
		(
			T iItem
		);

		void const DeleteBookmark ();
		void const SetBookmark ();

	protected:

		typedef struct PoolS
		{
			T Genotype;
			struct PoolS * Next;
			struct PoolS * Previous;
		} * PoolT;

		PoolT GetBookmark () const;
	private:

		PoolT Pool;
		PoolT PoolEnd;
		PoolT Bookmark;
		PoolT CurrentPoolItem;

		UnsignedIntegerT MaximumSizeOfPopulation;
		UnsignedIntegerT SizeOfPopulation;
};



#endif

// eof PopulationPool.h
