
#include "SelectionC.h"


extern MLCG RandomGenerator;


SelectionC::SelectionC
(
 	RealT const iLinearRankingBias,
	UnsignedIntegerT const iSizeOfPopulation
)
{
	LinearRankingBias = iLinearRankingBias;
	SizeOfPopulation = iSizeOfPopulation;

	PreWork1 = LinearRankingBias * LinearRankingBias;
	PreWork2 = 4.0 * (LinearRankingBias - 1);
	PreWork3 = 2.0 * (LinearRankingBias - 1);

} // SelectionC::SelectionC
		


SelectionC::~SelectionC ()
{

} // SelectionC::~SelectionC



UnsignedIntegerT const SelectionC::GetIndex () const
{
	RealT r = (RealT) (RandomGenerator.asLong () % PRECISION) / PRECISION;

	return (
			(UnsignedIntegerT)
			((RealT) SizeOfPopulation * (LinearRankingBias - sqrt (PreWork1 - PreWork2 * r)) / PreWork3)
			);
	
} // SelectionC::GetIndex

// eof SelectionC.cc
