/*
 * ArrayC.h - Template class implementing an array with buildin checks.
 *
 */

#ifndef ArrayC_h
#define ArrayC_h

#include "../Types.h"

template <class T>
class ArrayC
{
	public:

		ArrayC (unsigned int iSize)
		{
			Init (iSize);
		}

		ArrayC (ArrayC<T> const & iArray);

		ArrayC<T> const & operator=
		(
			ArrayC<T> const & iArray
		);

		BoolT const operator==
		(
			ArrayC<T> const & iArray
		);

		~ArrayC ()
		{
			delete [] Data;
		}

		unsigned int GetSize () const;
		T & operator[] (unsigned int iIndex);

	protected:

	private:

		unsigned int Size;

		T * Data;

		void const Init (unsigned int const iSize);

}; // ArrayC

#endif

// eof ArrayC.h
