/*
 * ArrayC.t - Template class implementing an array with buildin checks.
 *
 */

#include "ArrayC.h"



template <class T>
void const ArrayC<T>::Init (unsigned int const iSize)
{
	if (iSize < 1)
	{
		cerr << "Error: creation of array of size 0 requested." << endl;
		exit (1);
	}
	Size = iSize;

	Data = new T [Size];

} // ArrayC::Init



template <class T>
ArrayC<T>::ArrayC (ArrayC<T> const & iArray)
{
	Size = iArray.Size;
	Data = new T [Size];

	for (register unsigned int i = 0; i < Size; i++)
		Data [i] = iArray.Data [i];

} // ArrayC::ArrayC



template <class T>
ArrayC<T> const & ArrayC<T>::operator= (ArrayC<T> const & iArray)
{
	if (this != &iArray)
	{
		delete [] Data;
		Size = iArray.Size;
		Data = new T [Size];

		for (register unsigned int i = 0; i < Size; i++)
			Data [i] = iArray.Data [i];
	}
	return (*this);

} // ArrayC::operator=



template <class T>
BoolT const ArrayC<T>::operator==
(
	ArrayC<T> const & iArray
)
{
	BoolT Equal;

	if (this != &iArray)
	{
		Equal = true;
		for (register unsigned int i = 0; i < Size && Equal; i++)
			Equal = (Data [i] == iArray.Data [i]);

		return (Equal);
	}

	return (true);

} // ArrayC::operator==



template <class T>
unsigned int ArrayC<T>::GetSize () const
{
	return (Size);
	
}  // ArrayC::GetSize


template <class T>
T & ArrayC<T>::operator[] (unsigned int iIndex)
{
	if (iIndex >= Size)
	{
		cerr << "Error: out of bound index (" << iIndex << ") on array of size " << Size << "." << endl;
		exit (1);
	}
	return (Data [iIndex]);

} // ArrayC::operator[]


// eof ArrayC.t
