#include "FileC.h"


FileC::FileC
(
	StringT iFileName,
	BoolT iOverwrite
)
{
	FileName = strdup (iFileName);

	if (iOverwrite)
	{
		OutputFile.open (iFileName);
	}
	else
	{
		OutputFile.open (iFileName, ios::app);
	}

	if (!OutputFile.is_open ())
	{
		cerr << "Warning could not open output file \"" << FileName << "\".\n";
		IsOpen = false;
	}
	else
		IsOpen = true;
}


FileC::~FileC ()
{
	if (IsOpen)
		OutputFile.close ();
}



FileC & FileC::operator <<
(
	StringT const & iString
)
{
	if (IsOpen)
	{
		OutputFile << iString;
		OutputFile.flush ();
	}
	else
	{
		cerr << "Warning: the file \"" << FileName << "\" is not open.\n";
	}

	return (*this);
}



FileC & FileC::operator <<
(
	RealT const & iReal
)
{
	if (IsOpen)
	{
		OutputFile << iReal;
	}
	else
	{
		cerr << "Warning: the file \"" << FileName << "\" is not open.\n";
	}

	return (*this);
}



FileC & FileC::operator <<
(
	UnsignedIntegerT const & iUnsignedInteger
)
{
	if (IsOpen)
	{
		OutputFile << iUnsignedInteger;
	}
	else
	{
		cerr << "Warning: the file \"" << FileName << "\" is not open.\n";
	}

	return (*this);
}

// eof FileC.cc
