
/*
 * ConfigurationC.h - A general configuration file reader with classes.
 *
 */


#ifndef ConfigurationC_h
#define ConfigurationC_h 1

#include <fstream.h>
#include <stdlib.h>
#include <string.h>
#include "Types.h"

class ConfigurationC 
{
	public:
		ConfigurationC
		(
			StringT iFileName
		);

		~ConfigurationC ();

		UnsignedIntegerT const GetUnsignedIntegerItem
		(
			StringT const iClass, 
			StringT const iItem
		) const;

		PositiveIntegerT const GetPositiveIntegerItem
		(
			StringT const iClass, 
			StringT const iItem
		) const;


		IntegerT const GetIntegerItem
		(
			StringT const iClass, 
			StringT const iItem
		) const;

		RealT const GetRealItem
		(
			StringT const iClass,
			StringT const iItem
		) const;

		RealT const GetZeroToOneRealItem
		(
			StringT const iClass,
			StringT const iItem
		) const;

		StringT const GetStringItem
		(
			StringT const iClass,
			StringT const iItem
		) const;

		BoolT const GetBoolItem
		(
			StringT const iClass,
			StringT const iItem
		) const;

		void const Print () const;

	protected:

	private:

		UnsignedIntegerT NumberOfLabels;
		UnsignedIntegerT LargestString;

		StringT FileName;

		typedef struct ItemS
		{
			StringT Label;
			StringT Data;
		} ItemsT;

		ItemsT * Items;

}; // ConfigurationC

#endif

// eof ConfigurationC.h
