#ifndef StatisticsC_h
#define StatisticsC_h 1

#include "ConfigurationC.h"
#include "Common/FileC.h"

class StatisticsC 
{
	public:
		StatisticsC
		(
			StringT const iIntermediateFileName,
			StringT const iRunStatsFileName,
			StringT const iSuccessRateFileName,
			StringT const iEncountersDoneFileName,
			StringT const iGeneratedGenotypesFileName,
			StringT const iGenerationsFileName,
			StringT const iDirectory,
			BoolT const iOverwriteOutputFiles
		);

		~StatisticsC();

		void const WriteExperimentResult ();

		void const WriteOneParameterResult
		(
			RealT Connectivity,
			RealT Tightness
		);

		void const WriteOneProblemTestResult
		(
			BoolT iSucces,
			UnsignedIntegerT iNumberOfEncountersDone,
			UnsignedIntegerT iNumberOfGenerations,
			UnsignedIntegerT iNumberOfGeneratedGenotypes
		);

		void const WriteIntermediateResults ();

		FileC & GetFileToStoreSolutions ();

		StatisticsC & operator<<
		(
			StringT const iString
		);
		StatisticsC & operator<<
		(
			UnsignedIntegerT const iUnsignedInteger
		);
		StatisticsC & operator<<
		(
			BoolT const iBool
		);
		StatisticsC & operator<<
		(
			RealT const iReal
		);

	protected:

		void const Reset ();

	private:

		UnsignedIntegerT ProblemCounter;
		UnsignedIntegerT SuccessCounter;
		UnsignedIntegerT NumberOfEncountersDoneTotal;
		UnsignedIntegerT NumberOfEncountersDoneMaximum;
		UnsignedIntegerT NumberOfGenerationsTotal;
		UnsignedIntegerT NumberOfGenerationsMaximum;
		UnsignedIntegerT NumberOfGeneratedGenotypesTotal;
		UnsignedIntegerT NumberOfGeneratedGenotypesMaximum;

		FileC * PlotSuccessRateFile;
		FileC * PlotEncountersDoneFile;
		FileC * PlotGeneratedGenotypesFile;
		FileC * PlotGenerationsFile;
		FileC * RunStatsFile;
		//
		//FileC * IntermediateFile;
};

#endif


